# All files / src/node-obfuscators CatchClauseObfuscator.ts

100% Statements 16/16
100% Branches 2/2
100% Functions 2/2
100% Lines 16/16

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    681x

    1x

    1x
    1x
    1x
    1x

    1x

    1008x

    1008x

    1008x
    1008x

    1008x
    1008x

    1008x

    9072x
    3024x

     import * as estraverse from 'estraverse';
    import * as ESTree from 'estree';

    import { ICustomNode } from '../interfaces/custom-nodes/ICustomNode';
    import { IOptions } from '../interfaces/IOptions';

    import { NodeType } from '../enums/NodeType';

    import { AbstractNodeObfuscator } from './AbstractNodeObfuscator';
    import { IdentifierReplacer } from './replacers/IdentifierReplacer';
    import { Nodes } from '../Nodes';
    import { NodeUtils } from '../NodeUtils';

    /**
     * replaces:
     *     try {} catch (e) { console.log(e); };
     *
     * on:
     *     try {} catch (_0x12d45f) { console.log(_0x12d45f); };
     *
     */
    export class CatchClauseObfuscator extends AbstractNodeObfuscator {
        /**
         * @type {IdentifierReplacer}
         */
        private identifierReplacer: IdentifierReplacer;

        /**
         * @param nodes
         * @param options
         */
        constructor(nodes: Map <string, ICustomNode>, options: IOptions) {
            super(nodes, options);

            this.identifierReplacer = new IdentifierReplacer(this.nodes, this.options);
        }

        /**
         * @param catchClauseNode
         */
        public obfuscateNode (catchClauseNode: ESTree.CatchClause): void {
            this.storeCatchClauseParam(catchClauseNode);
            this.replaceCatchClauseParam(catchClauseNode);
        }

        /**
         * @param catchClauseNode
         */
        private storeCatchClauseParam (catchClauseNode: ESTree.CatchClause): void {
            NodeUtils.typedReplace(catchClauseNode.param, NodeType.Identifier, {
                enter: (node: ESTree.Identifier) => this.identifierReplacer.storeNames(node.name)
            });
        }

        /**
         * @param catchClauseNode
         */
        private replaceCatchClauseParam (catchClauseNode: ESTree.CatchClause): void {
            estraverse.replace(catchClauseNode, {
                enter: (node: ESTree.Node, parentNode: ESTree.Node): any => {
                    if (Nodes.isReplaceableIdentifierNode(node, parentNode)) {
                        node.name = this.identifierReplacer.replace(node.name);
                    }
                }
            });
        }
    }